<template>
    <div class="mb-3">
        <div v-if="text" class="form-label fs-6 fw-bold">{{ text }}</div>
        <div v-for="(value, index) in list" :key="index" class="input-group mb-1">
            <template v-if="ordered">
                <button type="button" class="btn btn-dark btn-sm" @click="moveValue(index, -1)">↑</button>
                <button type="button" class="btn btn-dark btn-sm" @click="moveValue(index, 1)">↓</button>
            </template>
            <input class="form-control" :value="displayKey ? list[index][displayKey] : list[index]"
                   @input="setValue(index, $event.target.value)"
                   :class="{'is-invalid': errors[`${errorPrefix}.${index}`]}" :readonly="readonly" :placeholder="placeholder" />
            <button type="button" class="btn btn-danger btn-sm" @click="removeValue(index)">x</button>
            <div v-if="errors[`${errorPrefix}.${index}`]" class="invalid-feedback">{{ errors[`${errorPrefix}.${index}`] }}</div>
        </div>
        <div class="input-group">
            <slot></slot>
            <button type="button" class="btn btn-success btn-sm" @click="addValue()">+</button>
        </div>
    </div>
</template>

<script>
    export default {
        inheritAttrs: false,
        
        props: {
            'text': String,
            'list': Array,
            'errors': Object,
            'errorPrefix': String,
            'ordered': Boolean,
            'readonly': Boolean,
            'default': Object,
            'displayKey': String,
            'placeholder': String,
        },
        
        methods: {
            setValue(index, value) {
                this.list[index] = value
            },
            
            addValue() {
                if (!(this.displayKey && this.default === null)) {
                    this.list.push(this.default)
                }
            },
            
            removeValue(index) {
                this.list.splice(index, 1)
            },
            
            moveValue(index, offset) {
                this.list.splice(index+offset, 0, this.list.splice(index, 1)[0])
            }
        },
    }
</script>